<template>
  <main>
    <mt-page-title
      :with-border="false"
      :with-padding="true"
      :link-to="{
        name: 'profil-dashboard-statistiques',
        params: { profil: 'admin' },
        query: { start: queryStart, end: queryEnd, onglet: 1 },
      }"
      link-text="Retour aux statistiques des organismes"
    >
      <h1 class="has-text-weight-bold is-size-3">Statistiques ‘‘{{ organisme.codeParent }} / {{ organisme.code }}’’</h1>
    </mt-page-title>
    <mt-box padding="0">
      <article class="mt-box-content">
        <form @submit.prevent="moisSelectionne">
          <b-message type="is-danger" size="is-small" class="is-size-7" :active="dateInError">
            La date de fin est antérieure à la date de début
          </b-message>
          <section class="mt-fields-section columns">
            <b-field label="Début de la période" class="column is-one-third">
              <b-datepicker
                v-model="start"
                placeholder="Sélectionnez une date de debut"
                :first-day-of-week="1"
                :month-names="monthNames"
                :day-names="dayNames"
                :date-parser="dateParse"
                editable
                icon="calendar-today"
                class="mt-input"
                @input="moisSelectionneDebut"
              />
            </b-field>

            <b-field label="Fin de la période" class="column is-one-third">
              <b-datepicker
                v-model="end"
                placeholder="Sélectionnez une date de fin"
                :first-day-of-week="1"
                :month-names="monthNames"
                :day-names="dayNames"
                :date-parser="dateParse"
                editable
                icon="calendar-today"
                class="mt-input"
                @input="moisSelectionneFin"
              />
            </b-field>
          </section>
        </form>
        <mt-list v-slot="{ item: stat }" :list="utilisateurStatisitique">
          <mt-list-item>
            <div class="columns is-vcentered">
              <div class="column cursor-as-default">
                <nuxt-link
                  :to="
                    profilLink({
                      name: 'dashboard-statistiques-id-utilisateurs-utilisateur',
                      params: { id: idOrganisme, utilisateur: stat.utilisateur.id },
                    })
                  "
                >
                  <mt-utilisateur :utilisateur="stat.utilisateur" />
                </nuxt-link>
                <time title="Dernière connexion">{{ dateFormatter(stat.derniereConnexion) }}</time>
              </div>
              <div
                class="column is-narrow is-size-7 cursor-as-default"
                :title="`${stat.nbActivitesCree} Activites Créee`"
              >
                {{ stat.nbActivitesCree }}
                <b-icon icon="clipboard-text" size="is-small"></b-icon>
              </div>
              <div
                class="column is-narrow is-size-7 cursor-as-default"
                :title="`${stat.nbParticipation} participations`"
              >
                {{ stat.nbParticipation }}
                <b-icon icon="clipboard-account" size="is-small"></b-icon>
              </div>
              <div
                class="column is-size-7 is-narrow  cursor-as-default"
                :title="`${stat.nbDisponibilite} jours ayant des disponibilités (disponible ou indisponible)`"
              >
                {{ stat.nbDisponibilite }}
                <b-icon icon="calendar" size="is-small"></b-icon>
              </div>
              <div
                class="column is-narrow is-size-7 cursor-as-default"
                :title="`${stat.nbDisponibiliteOk} jours disponibles`"
              >
                {{ stat.nbDisponibiliteOk }}
                <mt-disponibilite-puce is-disponible />
              </div>
              <div
                class="column is-2 is-size-7 cursor-as-default"
                :title="`Taux de remplissage des disponibilités sur ${stat.nbJours} j`"
              >
                <mt-stat-dispo :pourcentage="stat.remplissageDispo.pourcentage" />
              </div>
            </div>
          </mt-list-item>
        </mt-list>

        <mt-message-info
          >{{ utilisateurStatisitique.length }} utilisateurs, {{ envoyees.length + expirees.length }} invitations
          envoyées (dont {{ expirees.length }} invitations expirées)</mt-message-info
        >
      </article>
    </mt-box>
  </main>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtBox from '~/components/base/box';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import MtMessageInfo from '~/components/base/message/mt-message-info';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';
import { statistiqueMixin } from '~/components/mixins/statistiqueMixin';
import MtStatDispo from '~/components/statistique/mt-stat-dispo';

export default {
  components: {
    MtStatDispo,
    MtDisponibilitePuce,
    MtMessageInfo,
    MtUtilisateur,
    MtPageTitle,
    MtList,
    MtListItem,
    MtBox,
  },
  mixins: [DayMonthMixin, statistiqueMixin],
  computed: {
    queryStart() {
      return DateTime.fromJSDate(this.start).toFormat('dd/MM/yyyy', { locale: 'fr' });
    },
    queryEnd() {
      return DateTime.fromJSDate(this.end).toFormat('dd/MM/yyyy', { locale: 'fr' });
    },
  },
  async asyncData({ $api, params, query }) {
    const moisCourant = new Date();
    const idOrganisme = params.id;

    const start =
      query && query.start
        ? DateTime.fromFormat(query.start, 'dd/MM/yyyy', { locale: 'fr' })
        : DateTime.fromJSDate(moisCourant).startOf('month');

    const end =
      query && query.end
        ? DateTime.fromFormat(query.end, 'dd/MM/yyyy', { locale: 'fr' })
        : DateTime.fromJSDate(moisCourant).endOf('month');

    start.set({ hour: 8 });
    start.set({ hour: 18 });

    const [utilisateurStatisitique, { envoyees, expirees }, organisme] = await Promise.all([
      $api.statistiques.utilisateurParOrganisme(idOrganisme, start.toISO(), end.toISO()),
      $api.organisme(idOrganisme).invitations(),
      $api.organismes.get(idOrganisme),
    ]);

    return {
      start: start.toJSDate(),
      end: end.toJSDate(),
      utilisateurStatisitique,
      idOrganisme,
      envoyees,
      expirees,
      organisme,
    };
  },
  methods: {
    async moisSelectionneDebut() {
      this.start.setHours(8);
      this.end.setHours(18);
      if (this.start > this.end) {
        this.end = this.start;
      }
      this.utilisateurStatisitique = await this.$api.statistiques.utilisateurParOrganisme(
        this.idOrganisme,
        this.start.toISOString(),
        this.end.toISOString(),
      );
    },
    async moisSelectionneFin() {
      this.start.setHours(8);
      this.end.setHours(18);
      if (this.end < this.start) {
        this.start = this.end;
      }
      this.utilisateurStatisitique = await this.$api.statistiques.utilisateurParOrganisme(
        this.idOrganisme,
        this.start.toISOString(),
        this.end.toISOString(),
      );
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-filter-liste {
  margin-top: 1rem;
}
.column.is-narrow {
  padding: 0 0.8rem;
}
footer {
  padding: 0.5rem 0;
  margin-bottom: 1rem;
}

.cursor-as-default {
  cursor: default;
}
time {
  font-size: 0.75rem;
  color: $grey-light;
  font-style: italic;
}
</style>
